﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GeocodingWithDifferentProfiles.XLocate;

namespace GeocodingWithDifferentProfiles
{
    class Program
    {
        static void Main(string[] args)
        {
            // Step 1: Instantiate XLocate client
            XLocateWSService client = new XLocateWSService();

            // Step 2.1: Set CallerContext for adding log information into your basic response logs.
            CallerContext context = new CallerContext();
            context.log1 = "Test";
            context.log2 = "user";
            context.log3 = "";

            // Step 2.2 Set CallerContext properties to define profile and CoordFormat
            CallerContextProperty prop1 = new CallerContextProperty();
            prop1.key = "Profile";
            prop1.value = "fuzzy";
            CallerContextProperty prop2 = new CallerContextProperty();
            prop2.key = "CoordFormat";
            prop2.value = "PTV_MERCATOR";
            CallerContextProperty prop3 = new CallerContextProperty();
            prop2.key = "ResponseGeometry";
            prop2.value = GeometryEncoding.PLAIN.ToString();
            CallerContextProperty[] props = new CallerContextProperty[] { prop1, prop2, prop3 };
            context.wrappedProperties = props;

            // Step 3: Create address objects and collect them in an array
            //         The result quality changes, depending on how complete your information is
            Address addr1 = new Address();
            addr1.country = "L";
            addr1.postCode = "185";
            addr1.city = "Luxemburg";
            
            Address addr2 = new Address();
            addr2.country = "L";
            addr2.postCode = "1856";
            addr2.city = "Luxemburg";
            addr2.street = "Rue Evrard Ketten";
            
            Address addr3 = new Address();
            addr3.country = "L";
            addr3.postCode = "1856";
            addr3.city = "Luxemburg";
            addr3.street = "Rue Evrard Ketten";
            addr3.houseNumber = "40";

            Address[] addresses = new Address[] {addr1, addr2, addr3};

            try
            {
                // Step 5: Get address response, pass the CallerContext as a parameter
                AddressResponse[] responses = client.findAddresses(addresses, null, null, null, context);

                // Step 6: Output the results to the console
                foreach(AddressResponse ar in responses) 
                {
                    foreach (ResultAddress ra in ar.wrappedResultList)
                    {
                        Console.WriteLine(
                            String.Format("Found {0}~{1}~{2}~{3}~{4},",
                                ra.country, ra.postCode, ra.city, ra.street, ra.houseNumber)
                        );
                    }
                }
                Console.WriteLine("Press any key to exit...");
                Console.ReadLine();
            }
            catch (Exception e)
            {
                //TODO: proper exception handling
            }
        }
    }
}
