﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ReverseGeocodingfindLocations.XLocate;

namespace ReverseGeocodingfindLocations
{
    class Program
    {
        static void Main(string[] args)
        {
            // Step 1: Instantiate XLocate client
            XLocateWSService client = new XLocateWSService();

            // Step 2: Create locations and collect them in an array
            PlainPoint plainPoint1 = new PlainPoint();
            plainPoint1.x = 680099;
            plainPoint1.y = 6373765;
            Point point1 = new Point();
            point1.point = plainPoint1;

            PlainPoint plainPoint2 = new PlainPoint();
            plainPoint2.x = 679887;
            plainPoint2.y = 6373942;
            Point point2 = new Point();
            point2.point = plainPoint2;

            Location location1 = new Location();
            location1.coordinate = point1;

            Location location2 = new Location();
            location2.coordinate = point2;

            Location[] locations = new Location[] { location1, location2 };

            try
            {
                // Step 3: Get address responses
                AddressResponse[] responses = client.findLocations(locations, null, null, null, null);

                // Step 4: Output the results to the console
                for (int i = 0; i < responses.Length; i++)
                {
                    foreach (ResultAddress ra in responses[i].wrappedResultList)
                    {
                        Console.WriteLine(
                            String.Format("Found {0}~{1}~{2}~{3}~{4} at location: x={5} y={6}",
                                ra.country, ra.postCode, ra.city, ra.street, ra.houseNumber, ra.coordinates.point.x, ra.coordinates.point.y)
                        );
                    }
                }
                Console.WriteLine("Press any key to exit...");
                Console.ReadLine();
            }
            catch (Exception e)
            {
                //TODO: proper exception handling
            }
        }
    }
}
