﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RoutingBasic.XRoute;

namespace RoutingBasic
{
    class Program
    {
        static void Main(string[] args)
        {
            runSample();
        }

        private static void runSample()
        {
            
            // Step 1: instantiate xRoute client. Use the packages utils.
		    XRouteWSService xRouteClient = new XRouteWSService();

		    // Step 2.1: define way-points <start> and <destination>
		    Point startPoint = new Point();
		    startPoint.point = new PlainPoint { x = 681593.765751686, y = 6371793.192390807 } ;
		    WaypointDesc wpdStart = new WaypointDesc();
		    wpdStart.wrappedCoords = new Point[] { startPoint };
		    wpdStart.linkType = LinkType.NEXT_SEGMENT;

		    Point destPoint = new Point();
		    destPoint.point = new PlainPoint { x = 678909.5202224851, y = 6395906.712571196 } ;
		    WaypointDesc wpdDest = new WaypointDesc();
		    wpdDest.wrappedCoords = new Point[] { destPoint };
		    wpdDest.linkType = LinkType.NEXT_SEGMENT;

		    // Step 2.2: Set both way-points into the specific array WaypointDesc[]
		    WaypointDesc[] waypointDescs = new WaypointDesc[] { wpdStart, wpdDest };

		    try 
            {
			    // Step 3: Return result from object routeInfo
			    RouteInfo routeInfo = xRouteClient.calculateRouteInfo(waypointDescs, null, null, null);

			    // Step 4: simply print following information
                Console.WriteLine(String.Format("Internal costs: {0}(-); distance: {1}(m); time: {2}(s)", routeInfo.cost,
					    routeInfo.distance, routeInfo.time));
		    } catch (Exception e) 
            {
                //TODO: proper exception handling
            }
        }
    }
}
